/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.log.enums.YYLoggerTuJingEnum
 *  fire.pb.course.CourseManager
 *  fire.pb.item.ItemMaps
 *  fire.pb.item.Module
 *  fire.pb.pet.Module
 *  fire.pb.pet.Pet
 *  fire.pb.pet.PetColumn
 *  fire.pb.pet.PetManager
 *  fire.pb.pet.SRefreshPetInfo
 *  fire.pb.pet.SShenShouInc
 *  fire.pb.talk.MessageMgr
 *  mkdb.Procedure
 *  mkio.Protocol
 *  org.apache.log4j.Logger
 *  xbean.PetInfo
 */
package fire.pb.pet.shenshou;

import fire.log.enums.YYLoggerTuJingEnum;
import fire.pb.course.CourseManager;
import fire.pb.item.ItemMaps;
import fire.pb.pet.Module;
import fire.pb.pet.Pet;
import fire.pb.pet.PetColumn;
import fire.pb.pet.PetManager;
import fire.pb.pet.SRefreshPetInfo;
import fire.pb.pet.SShenShouInc;
import fire.pb.talk.MessageMgr;
import mkdb.Procedure;
import mkio.Protocol;
import org.apache.log4j.Logger;
import xbean.PetInfo;

public class PShenShouYangCheng
extends Procedure {
    public static final Logger logger = Logger.getLogger((String)"SYSTEM");
    private final long roleId;
    private final int petKey;

    public PShenShouYangCheng(long roleId, int petKey) {
        this.roleId = roleId;
        this.petKey = petKey;
    }

    protected boolean process() throws Exception {
        PetColumn petCol = new PetColumn(this.roleId, 1, false);
        Pet pet = petCol.getPet(this.petKey);
        if (pet == null) {
            MessageMgr.sendMsgNotify((long)this.roleId, (int)162105, null);
            logger.error((Object)"神兽养成,petkey对应的宠物不符合要求或不存在");
            return false;
        }
        if (pet.isLocked() != -1L) {
            MessageMgr.psendMsgNotify((long)this.roleId, (int)Pet.PET_LOCK_ERROR_MSG, null);
            return true;
        }
        PetManager petManager = Module.getInstance().getPetManager();
        if (null == petManager) {
            return false;
        }
        PetInfo petInfo = petCol.getPetInfo(this.petKey);
        if (petInfo == null) {
            return false;
        }
        int shenshouinccount = petInfo.getShenshouinccount();
        if (shenshouinccount >= 100) {
            MessageMgr.sendMsgNotify((long)this.roleId, (int)162096, null);
            return false;
        }
        SShenShouInc attConf = petManager.getShenShouIncConfig(petInfo.getId(), shenshouinccount);
        if (attConf == null) {
            MessageMgr.sendMsgNotify((long)this.roleId, (int)162096, null);
            logger.error((Object)("角色id " + this.roleId + "错误:神兽养成次数为" + shenshouinccount));
            return false;
        }
        int itemId = attConf.itemid;
        int needItemNum = attConf.itemnum;
        ItemMaps bagContainer = fire.pb.item.Module.getInstance().getItemMaps(this.roleId, 1, false);
        if (bagContainer == null) {
            logger.error((Object)("角色id " + this.roleId + "神兽养成\t背包错误"));
            return false;
        }
        int curNum = bagContainer.getItemNum(itemId, 0);
        if (curNum < needItemNum) {
            MessageMgr.sendMsgNotify((long)this.roleId, (int)162100, null);
            return false;
        }
        if (petInfo.getLevel() < attConf.getInclv()) {
            return false;
        }
        petInfo.setGrowrate(petInfo.getGrowrate() + attConf.getAttinc());
        petInfo.setBornattackapt(petInfo.getBornattackapt() + attConf.getAtkinc());
        petInfo.setBorndefendapt(petInfo.getBorndefendapt() + attConf.getDefinc());
        petInfo.setBornphyforceapt(petInfo.getBornphyforceapt() + attConf.getHpinc());
        petInfo.setBornmagicapt(petInfo.getBornmagicapt() + attConf.getMpinc());
        petInfo.setBornspeedapt(petInfo.getBornspeedapt() + attConf.getSpdinc());
        petInfo.setShenshouinccount(shenshouinccount + 1);
        pet.updatePetScoreWhileChange();
        CourseManager.checkAchieveCourse((long)this.roleId, (int)31, (int)pet.getPetInfo().getPetscore());
        int usedNum = bagContainer.removeItemById(itemId, needItemNum, YYLoggerTuJingEnum.tujing_Value_shenshou, itemId, "重置神兽");
        if (usedNum != needItemNum) {
            return false;
        }
        SRefreshPetInfo refresh = new SRefreshPetInfo(pet.getProtocolPet());
        PShenShouYangCheng.psendWhileCommit((long)this.roleId, (Protocol)refresh);
        MessageMgr.sendMsgNotify((long)this.roleId, (int)162095, null);
        logger.error((Object)("角色id " + this.roleId + "养成神兽\t扣除道具，物品id" + itemId + "数量" + needItemNum));
        return true;
    }
}

